const fs = require("fs");
const dls = require("windows-drive-letters");
const vdf2 = require("simple-vdf2");
const config_paths = [
    ':/Program Files (x86)/Steam/config/loginusers.vdf',
    ':/Program Files/Steam/config/loginusers.vdf'
];

module.exports = () => {
    return new Promise((resolve, reject) => {
        dls.usedLetters().then((letters) => {
            letters.forEach(function(letter) {
                config_paths.forEach(function(path) {
                    const config_file = letter + path;
                    fs.access(config_file, fs.F_OK, (err) => {
                        if (err) return;
                        fs.readFile(config_file, "utf8", function(err, data) {
                            const users = vdf2.parse(data);
                            for(var property in users.users) {
                                if (parseInt(users.users[property].AllowAutoLogin) && parseInt(users.users[property].MostRecent)) {
                                    resolve({
                                        steamId: property,
                                        name: users.users[property].AccountName,
                                        status: "success"
                                    });
                                }
                            }
                            resolve({ status: "error" });
                        });
                    })
                })
            })
        }).catch((err) => {
            console.error(err);
            reject(err);
        });
    });
};
